// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: FTAServerChannel.java,v 1.6 2001/06/21 14:57:10 veit Exp $

package jfta.base;

import java.net.*;
import java.util.*;
import java.io.*;

import jfta.exception.*;

/**
 * this is an abstract 
 */
public abstract class FTAServerChannel {
    protected InetAddress _addr;
    protected int _port;
    protected FTAListenerList _listeners;
    protected ThreadGroup _systg;

    protected FTAServerChannel(ThreadGroup tg,InetAddress addr,int port) {
	_listeners = new FTAListenerList();
	_addr = addr;
	_port = port;
	_systg = tg;
    }

    public final InetAddress getInetAddress() {
	return _addr;
    }

    public final int getPort() {
	return _port;
    }

    public final FTAListenerList getListeners() {
	return _listeners;
    }

    /**
     * register a class to be notified for a multicast message
     */
    public final void addListener(int msgtype,FTAListenerI lst,
				  int filter) {
	_listeners.addListener(msgtype,lst,filter);
    }
  
    /**
     * register a class to be notified for a multicast message
     */ 
    public final void removeListener(int msgtype,FTAListenerI lst) {
	_listeners.removeListener(msgtype,lst);
    }

    public abstract void close() throws IOException;
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
