// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: FTADTopServlet.java,v 1.6 2001/06/21 14:57:10 veit Exp $

package jfta.bootstrap;

import java.net.*;
import java.io.*;
import java.util.*;

import jfta.base.*;
import jfta.exception.*;
import jfta.http.*;

public class FTADTopServlet extends FTAServlet {

    private static FTAService _svc = FTAService.Instance();
    private FTADaemon _daemon;

    /**
     * mandatory constructor
     */
    public FTADTopServlet() {
	super();
    }

    /**
     * init method
     */
    public void init(FTAHttpServer server,Vector argv)
	throws FTAArgumentException {

	// get daemon
	_daemon = (FTADaemon)server.getContainer();
    }

    /**
     * reply method.
     */
    public FTAServletReply reply(FTAServletRequest req) {
	FTAHttpServer server = req.getServer();
	String host = _svc.getFQDNname();
	
	FTAHtmlFile f = new FTAHtmlFile("FTADaemon at "+ host);

	f.h2("Properties");
	f.beginUL();
	f.item("CLASSPATH: "); 
	f.b(System.getProperty("CLASSPATH"));
	f.endUL();

	f.h2("Facilities");
	f.beginUL();

	/** enable this again for udp
	 * f.item(); f.anchor("/dir.html","Directory Server");
	 */
	f.item(); f.anchor("/daemons/index.html","Daemons");
	f.item(); f.anchor("/systems/index.html","Systems");
	f.item(); f.anchor("/serverlog.html","Server Log");
	f.endUL();
	f.h2("Functions");
	f.beginUL();
	f.item(); f.anchor("/daemons/newsys.html",
			   "Start a new FTASystem");
	f.item(); f.anchor("/daemons/shutsys.html",
			   "Shutdown an FTASystem");
	f.item(); f.anchor("/cgi-bin/shutdowndaemon.ftad",
			   "Shutdown <b>this</b> daemon");
	f.item(); f.anchor("/cgi-bin/shutdownalldaemons.ftad",
			   "Shutdown <b>all</b> daemons");
	f.endUL();

	f.h2("Information");
	f.beginUL();
	f.item(); f.anchor("/docs/userguide/","jFTA Users guide");
	f.item(); f.anchor("/docs/","Online API documentation");
	f.item(); f.anchor("/jfta","FTA at AiS ARC page");
	f.item(); f.anchor("/arc","ARC (robot control architectures) research group");
	f.item(); f.anchor("/ais","AiS Research Institute");
	f.item(); f.anchor("/gmd","GMD National Research Center for IT");

	f.endUL();
	_daemon.stdFinish(f);
	return f;
    }
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
