// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.ping;

import jfta.actors.*;
import jfta.exception.*;
import jfta.system.*;

public class PingPongInit extends FTAInitActor implements FTAActorI {

  String[] host = { "arc01.arc.gmd.de",
		    "arc02.arc.gmd.de",
		    "arc03.arc.gmd.de",
		    "arc04.arc.gmd.de",
		    "arc05.arc.gmd.de",
		    "arc06.arc.gmd.de",
		    "arc07.arc.gmd.de",
		    "arc08.arc.gmd.de"
  };
  String[] actorargs = {"ping","pong"};
  
  public int eval() throws FTAEvalActorException {
    int i,j;
    
    try {
      System.out.println("Ping Pong INIT ACTOR CALLED");
      
      // add new hosts
      for (i=0; i<host.length; i++) {
	System.out.println("Add host " + host[i]);
	addHost(host[i]);
      }
      // create new Tagboards
      for (i=0; i<host.length; i++) {
	System.out.println("Add dist TB tbd"+i+" on host " + host[i]);
	addTagboard("tbd"+i,host[i],1);
      }
	
      // create new Ensembles
      for (i=0; i<host.length; i++) {
	  System.out.println("Add dist EN end"+i+" on host " + host[i]);
	  addEnsemble("end"+i,host[i],1);	
      }

      // add sync relations
      /** sync with reading actor 
       *for (i=1; i<host.length; i++) {
       *System.out.println("addETSync : end0 - tbd"+i); 
       *addETSync("end0","tbd"+i);
       *System.out.println("addETSync : end"+i+" - tbd0");
       *addETSync("end"+i,"tbd0");
       *}
       */

      /** sync with writing actor */
      for (i=0; i<host.length; i++) {
       System.out.println("addETSync : end"+i+" - tbd"+i); 
       addETSync("end"+i,"tbd"+i);
      }

      //System.out.println("addEESync : end0 - end1 (1:1)");
      //addEESync("end0","end1",1,1);
      
      // add actors
      System.out.println("addActor: ping (end0)");
      addActor(host[0],"end0", "ping",
		 "jfta.demo.ping.PingActor",
		 actorargs);	
      for (i=1; i<host.length; i++) {
	  System.out.println("addActor: pong"+i+" (end"+i+")");	
	  actorargs[0] = "tbd" + i;
	  addActor(host[i],"end"+i, "pong"+i,
		   "jfta.demo.ping.PongActor",
		   actorargs);	
      }
    } 
    catch(Exception e) {
	e.printStackTrace();
    }
    System.out.println("Ping Pong INIT ACTOR FINISHED");
    return FTAActor.TERMINATE;
  }  
  
  /**
    */
  public PingPongInit() {
    super();
  }
    
  /**
    */
  public void init(String[] args) throws FTAArgumentException {
  }
}
