// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: Constants.java,v 1.2 2001/06/21 14:57:18 veit Exp $

package jfta.demo.simrob;

import jfta.tags.*;
import jfta.actors.*;

public interface Constants {

  /* integer constants */
  public final static int RIGHTWHEEL = 0;
  public final static int LEFTWHEEL = 1;

  public final static int SENSORTB = 1;
  public final static int SPEEDTB = 2;
  public final static int CMDTB = 3;
  public final static int CONFTB = 4;
  public final static int ROBOTEN = 5;

  // flags
  public static int DRAWNAME = 1;
  
  // object types
  public final static int MAPLINE = 1;
  public final static int MAPWALL = 2;
  public final static int MAPCIRCLE = 3;
  public final static int MAPQUAD = 4;
  public final static int MAPTRIANGLE = 5;
  public final static int MAPDOOR = 6; // An ethernet controlled door   
  public final static int MAPSWALL = 7; 
  public final static int MAPBOX = 8;
  public final static int MAPPOLY = 9;
  public final static int MAP_MAX = 10;

  /* static tagboard names */
  public final static String locTB = "Location";
  public final static String enviTB = "Environment";
  public final static String msgTB = "Messages";

  public final static String DEFAULT_DISPLAY = "jfta.demo.simrob.Display";

  /* patterns */
  public final static FTATagPattern mappattern =
    new FTATagPattern("jfta.demo.simrob.MapObjTag");
  public final static FTATagPattern msgpattern = 
    new FTATagPattern("jfta.demo.simrob.MsgTag");
  public final static FTATagPattern mlaypattern =
    new FTATagPattern("jfta.demo.simrob.VConfMotLayoutTag");
  public final static FTATagPattern vlocpattern =
    new FTATagPattern("jfta.demo.simrob.VConfVehiclelocTag");
  public final static FTATagPattern vconfpattern = 
    new FTATagPattern("jfta.demo.simrob.VConfVehiclelocTag");
  public final static FTATagPattern slaypattern = 
    new FTATagPattern("jfta.demo.simrob.SensLayoutTag");
  public final static FTATagPattern vehpattern = 
    new FTATagPattern("jfta.demo.simrob.VehCmdTag");
  public final static FTATagPattern modpattern =
    new FTATagPattern("jfta.demo.simrob.ModObjTag");



}
