// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// This interface is required for the commands of the LineParser class.

package jfta.demo.simrob;

import java.io.*;
import java.util.*;

/**
  * The LineParse interface has to be implemented by all commands usable
  * with the LineParser class
  * @author Holger Veit
  * @version $Id: LineParse.java,v 1.2 2001/06/21 14:57:18 veit Exp $
  * @see jfta.demo.simrob.LineParse
  */
public interface LineParse extends Serializable {
  /**
    * This method will parse a complete line of text until an TT_EOL or TT_EOF
    * is seen.
    * @param st StreamTokenizer used to retrieve tokens from the stream
    *  one at a time
    * @param obj abstract object that the routine will access to store
    * the parsed data into.
    * @see java.io.Streamtokenizer
    * @return false if an application specific "end_of_stream" token was
    * found, this will immediately terminate the file parsing, even if EOF
    * is not yet reached.
    */
  public boolean read(StreamTokenizer st,Object obj) throws LineParserException;
}
