// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.simrob;

import java.io.*;
import java.util.*;

public class LineParserTest {

  private Hashtable cmdlist;

  // accepts three commands:
  // CMD1 STRING STRING STRING
  // CMD2 STRING DOUBLE
  // CMD3 INT STRING

  private class Cmd1 extends Object implements LineParse {
    public boolean read(StreamTokenizer st,Object obj)
      throws LineParserException {
        System.out.println("   Start Cmd1");
	System.out.println("      arg1=" + LineParser.getString(st,true));
	System.out.println("      arg2=" + LineParser.getString(st,true));
	System.out.println("      arg3=" + LineParser.getString(st,true));
	System.out.println("   End Cmd1");
	return true;
    }
  }

  private class Cmd2 extends Object implements LineParse {
    public boolean read(StreamTokenizer st,Object obj)
      throws LineParserException {
        System.out.println("   Start Cmd2");
	System.out.println("      arg1=" + LineParser.getString(st,true));
	System.out.println("      arg2=" + LineParser.getDouble(st));
	System.out.println("   End Cmd2");
	return true;
    }
  }

  private class Cmd3 extends Object implements LineParse {
    public boolean read(StreamTokenizer st,Object obj)
      throws LineParserException {
        System.out.println("   Start Cmd3");
	System.out.println("      arg1=" + (int)LineParser.getDouble(st));
	System.out.println("      arg2=" + LineParser.getString(st,true));
	System.out.println("   End Cmd3");
	return true;
    }
  }


  public LineParserTest() {
    cmdlist = new Hashtable();
    cmdlist.put("cmd1",new Cmd1());
    cmdlist.put("cmd2",new Cmd2());
    cmdlist.put("cmd3",new Cmd3());

    try {
      String teststring1 = "Cmd1 argument1 string2 Data3";
      System.out.println("*** Test1 (read from string)");
      LineParser p = new LineParser(new StringReader(teststring1),this,cmdlist);
      System.out.println("*** Test2 (read from file)");
      String filename = "lptestfile";
      p = new LineParser(filename,this,cmdlist);
      System.out.println("*** All tests finished");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    new LineParserTest();
  }
}
