// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.simrob;

import jfta.base.*;
import jfta.exception.*;
import jfta.tags.*;

import java.awt.*;
import java.awt.geom.*;

/**
  * This tag stores a Map Box Object
  * @author Holger Veit
  * @version $Id: MapBoxObjTag.java,v 1.2 2001/06/21 14:57:18 veit Exp $
  * @see jfta.demo.simrob.MapObjTag
  */
public class MapBoxObjTag extends MapObjTag {

  /**
    */
  protected Point p1,p2;

  /**
    * public access methods
    */
  public Point2D getP1() {
    return p1;
  }

  public Point2D getP2() {
    return p2;
  }

  public int getObjType() {
    return MapObjTag.MAPWALL;
  }

  /**
    * mandatory empty constructor
    */
  public MapBoxObjTag() {
    super();
  }

  /**
    * custom constructor
    */
  public MapBoxObjTag(String name,Color col,int stroke,
		      int x1,int y1,int x2,int y2) {
    super(name,col,stroke);
    p1 = new Point(x1,y1);
    p2 = new Point(x2,y2);
    shape = new Rectangle(x1,y1,x2-x1,y2-y1);
  }
}
