// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

//Source file: /home/rteams/jfta/jfta/actors/FTAInitActor.java

package jfta.actors;

import jfta.exception.*;
import jfta.system.FTAMainI;
import java.rmi.RemoteException;
import jfta.ensemble.FTARatio;

public class FTATestInitActor extends FTAInitActor implements FTAActorI {
    String[] host = { "arctis.arc.gmd.de",
		      "arc01.arc.gmd.de",
		      "arc02.arc.gmd.de",
		      "arc03.arc.gmd.de",
		      "arc05.arc.gmd.de",
		      "arc06.arc.gmd.de"
    };

    /**
    */
    public int eval() throws FTAEvalActorException {
	int i;

	try {
	    System.out.println("TEST INIT ACTOR CALLED");
	    
	    // add new hosts
	    for (i=0; i<host.length; i++) {
		System.out.println("Add host " + host[i]);
		addHost(host[i]);
	    }

	    // create new Tagboards
	    for (i=0; i<host.length; i++) {
		System.out.println("Add dist TB on host " + host[i]);
		addTagboard("tbd"+i,host[i],true);
	    }
	    for (i=0; i<host.length; i++) {
		System.out.println("Add nondist TB on host " + host[i]);
		addTagboard("tbn"+i,host[i],false);
	    }

	    // create new Ensembles
	    for (i=0; i<host.length; i++) {
		System.out.println("Add dist EN on host " + host[i]);
		addEnsemble("end"+i,host[i],true);
	    }
	    for (i=0; i<host.length; i++) {
		System.out.println("Add nondist EN on host " + host[i]);
		addEnsemble("enn"+i,host[i],false);
	    }
	} catch(Exception e) {
	    e.printStackTrace();
	}
	return FTAActor.TERMINATE;
    }
    
    /**
    */
    public FTATestInitActor() {
	super();
    }
    
    /**
    */
    public void init(String[] args) throws FTAArgumentException {
	// nothing required
    }
}
