// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// This is a template for an own tag type
// insert stuff at all locations that have [XXXXXX]
// by default, this file cannot be compiled.
// $Id: TagTemplate.java,v 1.4 2001/06/21 14:57:27 veit Exp $


package [MYPACKAGE];

import jfta.exception.*;
import jfta.tags.*;
import jfta.http.*;

[MYPACKAGES_TO_IMPORT];

/**
 * This tag does [DESCRIPTION]
 * @author [AUTHOR]
 * @version $Id: TagTemplate.java,v 1.4 2001/06/21 14:57:27 veit Exp $
 */
public class [MYTAG] extends FTATag {
    
    /**
     * [ADD ATTRIBUTES HERE
     * MAKE THEM PRIVATE OR PROTECTED]
     */
    [ATTRIBUTES];
    
    /**
     * [ADD 'GET' ACCESS METHODS FOR STORED DATA HERE]
     */
    [METHODS];
    
    /**
     * [IMPLEMENT THIS METHOD IF YOU WANT TO GROUP TAGS TOGETHER
     * OTHERWISE REMOVE THIS METHOD FROM HERE (USES BASE CLASS METHOD)]
     * @return the storetype for this tag
     */
    public String getStoreType() {
	return [MYGROUPTYPE];
    }
    
    /**
     * [IMPLEMENT THIS METHOD IF YOU WANT TO OPTIMIZE THE STORAGE SIZE
     * FOR THESE TAGS IN THE TAGBOARD, AND KNOW THE APPROX. NUMBER OF
     * TAGS OF THIS TYPE TO OCCUR.
     * OTHERWISE REMOVE THIS METHOD FROM HERE (USES BASE CLASS METHOD)]
     * @return the approx. number of tags to be expected during a flip cycle
     */
    public int getCapacityHint() {
	return [APPROX_CAPACITY_NEEDED];
    }
    
    /**
     * [IMPLEMENT THIS *EMPTY* CONSTRUCTOR (MANDATORY)]
     */
    public [MYTAG]() {
	super();
	[INIT_ATTRIBUTES];
    }
    
    /**
     * [IMPLEMENT THIS METHOD TO PARSE ARGUMENTS AND FINALLY INITIALIZE
     * THE TAG]
     * @param args the argument string used to initialize the tag
     * @exception FTAArgumentException Thrown in case of an invalid or missing
     *   argument
     */
    public void init(String[] args) throws FTAArgumentException {
	[INIT_IMPLEMENTATION];
    }

    /**
     * post initialize the tag.
     * This method is called when the tag is received at the
     * target TagboardSub before it is stored. This allows to
     * do late initializations. The default method does nothing.
     */
    public void postInit() {
	[POSTINIT_IMPLEMENTATION]
    }

    /**
     * provide HTML Information about this object and its contained objects
     */
    public FTAServletReply reply(FTAServletRequest req) {
	[REPLY_IMPLEMENTATION]
    }
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
